using System;
using System.IO;
using System.Xml;
using Commons.Xml.Relaxng;
using Commons.Xml.Relaxng.Rnc;
using Commons.Xml.Nvdl;

public class Test
{
	public static void Main (string [] args)
	{
		string target = args [0];
               // target is a word used to concatenate the name of the 
               //validating nvdl file and the xml file being validated


		NvdlRules rules = NvdlReader.Read (new XmlTextReader (target + ".nvdl"));
                Console.WriteLine("working");


		XmlReader xr = new XmlTextReader (target + ".xml");

         try{
            NvdlValidatingReader vr = new NvdlValidatingReader (xr, rules);
            //The exception raised by this try is not in NVDLValidatingReader, it
            //is in doc.Load! If the validation is considered to have been 
            //succesful
            //the xml document is returned, and thus raises no exception.
	    XmlDocument doc = new XmlDocument ();
          doc.Load(vr);
          doc.Save(Console.Out);

            }
	    catch(Exception ex)
           {
		Console.WriteLine(ex.ToString());

              }  finally {
               Console.WriteLine(" NVDL Validation finished");
                }
	}
}

